## choreonoid 1.5.0%2Bdfsg

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6)
cmake_policy(SET CMP0003 NEW)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

include(FindPkgConfig)
include(CheckIncludeFiles)

project(Choreonoid)

# set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_modules/)

set(CNOID_MAJOR_VERSION 1) 
set(CNOID_MINOR_VERSION 5)
set(CNOID_PATCH_VERSION 0)
set(CNOID_VERSION ${CNOID_MAJOR_VERSION}.${CNOID_MINOR_VERSION})
set(CNOID_FULL_VERSION ${CNOID_MAJOR_VERSION}.${CNOID_MINOR_VERSION}.${CNOID_PATCH_VERSION})

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

set(CNOID_DIR ${CMAKE_INSTALL_PREFIX})
set(CNOID_SUBDIR choreonoid-${CNOID_VERSION})
set(CNOID_PLUGIN_SUBDIR lib/${CNOID_SUBDIR})

if(WIN32)
  set(CNOID_HEADER_SUBDIR "include")
  set(CNOID_SHARE_SUBDIR "share")
  set(CNOID_DOC_SUBDIR "share/doc")
else()
  set(CNOID_HEADER_SUBDIR "include/${CNOID_SUBDIR}")
  set(CNOID_SHARE_SUBDIR "share/${CNOID_SUBDIR}")
  set(CNOID_DOC_SUBDIR "share/doc/${CNOID_SUBDIR}")
endif()

set(CNOID_SHARE_DIR "${CNOID_DIR}/${CNOID_SHARE_SUBDIR}")

set(CNOID_SOURCE_SHARE_DIR "${PROJECT_SOURCE_DIR}/share")


option(ENABLE_GUI "Enable GUI components" ON)

if(WIN32)
  set(DEFAULT_INSTALL_SDK OFF)
  set(DEFAULT_INSTALL_RUNTIME_DEPENDENCIES ON)
else()
  set(DEFAULT_INSTALL_SDK ON)
  set(DEFAULT_INSTALL_RUNTIME_DEPENDENCIES OFF)
endif()

option(INSTALL_RUNTIME_DEPENDENCIES "Installing the runtimes of external libraries" ${DEFAULT_INSTALL_RUNTIME_DEPENDENCIES})
option(INSTALL_SDK "Installing SDK files such as header files" ${DEFAULT_INSTALL_SDK})
option(INSTALL_SDK_WITH_EXTLIBS "The SDK installation includes the external libraries" OFF)

if(MSVC AND CMAKE_CL_64)
   add_definitions(-D_WIN64)
endif()

if(MSVC)
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_DEBUG _ITERATOR_DEBUG_LEVEL=1)
endif()

function(install_external_libraries dll_dir lib_dir)

  set(libraries ${ARGV})

  list(REMOVE_AT libraries 0 1)
  if(INSTALL_RUNTIME_DEPENDENCIES AND MSVC)
    set(conf general)
    foreach(library ${libraries})
      if(library STREQUAL general)
	set(conf general)
      elseif(library STREQUAL optimized)
	set(conf optimized)
      elseif(library STREQUAL debug)
	set(conf debug)
      else()
	get_filename_component(filename ${library} NAME_WE)
	if(conf STREQUAL general)
	  if(EXISTS ${dll_dir}/${filename}.dll)
	    install(PROGRAMS ${dll_dir}/${filename}.dll DESTINATION bin)
	  endif()
	  if(EXISTS ${lib_dir}/${filename}.lib AND INSTALL_SDK_WITH_EXTLIBS)
	    install(PROGRAMS ${lib_dir}/${filename}.lib DESTINATION lib)
	  endif()
	elseif(conf STREQUAL optimized)
	  if(EXISTS ${dll_dir}/${filename}.dll)
	    install(PROGRAMS ${dll_dir}/${filename}.dll DESTINATION bin CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
	  endif()
	  if(EXISTS ${lib_dir}/${filename}.lib AND INSTALL_SDK_WITH_EXTLIBS)
	    install(PROGRAMS ${lib_dir}/${filename}.lib DESTINATION lib CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
	  endif()
	elseif(conf STREQUAL debug)
	  if(EXISTS ${dll_dir}/${filename}.dll)
	    install(PROGRAMS ${dll_dir}/${filename}.dll DESTINATION bin CONFIGURATIONS Debug)
	  endif()
	  if(EXISTS ${lib_dir}/${filename}.lib AND INSTALL_SDK_WITH_EXTLIBS)
	    install(PROGRAMS ${lib_dir}/${filename}.lib DESTINATION lib CONFIGURATIONS Debug)
	  endif()
	endif()
      endif()
    endforeach()
  endif()

endfunction()



if(NOT CMAKE_BUILD_TYPE)
  set(
    CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif()

if(UNIX)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -finline-functions")
  option(ENABLE_GCC_FVISIBILITY_HIDDEN "Use the -fvisibility=hidden option when the sources are compiled" ON)
endif()

set(ADDITIONAL_CXX_FLAGS_RELEASE ${ADDITIONAL_CXX_FLAGS_RELEASE} CACHE STRING "Additional c++ compiler optimization flags")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${EXTRA_CXX_FLAGS_RELEASE} ${ADDITIONAL_CXX_FLAGS_RELEASE}")


if(MSVC)

  set(ext_compiler_options "/Ob2 /Ox /Oi /Ot /Oy /GT /GS- /fp:fast")
  if(CMAKE_CL_64)
    set(MSVC_ENABLE_SSE OFF CACHE BOOL "Enable SSE instructions on VC++." FORCE)
  else()
    option(MSVC_ENABLE_SSE "Enable SSE instructions on VC++." ON)
  endif()
  if(MSVC_ENABLE_SSE)
    set(ext_compiler_options "${ext_compiler_options} /arch:SSE /arch:SSE2 /fp:fast")
  endif()
  option(MSVC_ENABLE_AVX "Enable AVX instructions on VC++." OFF)
  if(MSVC_ENABLE_AVX)
    set(ext_compiler_options "${ext_compiler_options} /arch:AVX")
  endif()
  option(MSVC_ENABLE_AVX2 "Enable AVX2 instructions on VC++." OFF)
  if(MSVC_ENABLE_AVX2)
    set(ext_compiler_options "${ext_compiler_options} /arch:AVX2")
  endif()
  set(ext_linker_options "")

  option(MSVC_ENABLE_GLOBAL_OPTIMIZATION "Global optimization with compiler option /GL and linker option /LTCG" ON)
  if(MSVC_ENABLE_GLOBAL_OPTIMIZATION)
    set(ext_compiler_options "${ext_compiler_options} /GL")
    set(ext_linker_options "${ext_linker_options} /LTCG")
  endif()

  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${ext_compiler_options}")
  set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} ${ext_linker_options}")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${ext_linker_options}")
  set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} ${ext_linker_options}")

  if(MSVC_ENABLE_SSE)
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /GS- /fp:fast /arch:SSE2 /arch:SSE2")

    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /fp:fast /arch:SSE2 /arch:SSE2")
  endif()
endif()


if(ENABLE_GUI)
  FIND_PACKAGE(OpenGL)
  include_directories(${OPENGL_INCLUDE_DIR})
endif()


option(ENABLE_INSTALL_RPATH "Enable RPATH setting for installed binary files" ON)

if(ENABLE_INSTALL_RPATH)
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  if(APPLE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE) 
  else()
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
  endif()
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
else()
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
  set(CMAKE_INSTALL_RPATH "")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
endif()


option(CNOID_ENABLE_BACKWARD_COMPATIBILITY "Enable some backward compatibility" OFF)
if(CNOID_ENABLE_BACKWARD_COMPATIBILITY)
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS CNOID_BACKWARD_COMPATIBILITY)
endif()


# commands
if(UNIX)
  set(RMDIR rm -fr)
elseif(WIN32)
  set(RMDIR rmdir /S/Q)
endif()

# check "dlfcn.h" for using dlopen() and dlclose()
if(UNIX)
  check_include_files(dlfcn.h HAVE_DLFCN_H)
  if(NOT HAVE_DLFCN_H)
    message(FATAL_ERROR "Could not find dlfcn.h")
  endif()
endif()


# gettext
option(CNOID_ENABLE_GETTEXT "Enable the gettext library and translation messages for the internationalization" ON)

if(CNOID_ENABLE_GETTEXT)
  if(WIN32)
#    if(CMAKE_CL_64)
#      FIND_PROGRAM(GETTEXT_MSGFMT_EXECUTABLE msgfmt ${PROJECT_SOURCE_DIR}/thirdparty/windows64/bin)
#    else()
      FIND_PROGRAM(GETTEXT_MSGFMT_EXECUTABLE msgfmt ${PROJECT_SOURCE_DIR}/thirdparty/windows/bin)
#    endif()
  else()
    FIND_PROGRAM(GETTEXT_MSGFMT_EXECUTABLE msgfmt)
  endif()
  if(NOT GETTEXT_MSGFMT_EXECUTABLE)
    message(FATAL_ERROR "Could not find the msgfmt command and gettext cannot be enabled.")
  endif()
  if(WIN32 AND CMAKE_CL_64)
    set(GETTEXT_DIR ${PROJECT_SOURCE_DIR}/thirdparty/windows64)
  else()
    get_filename_component(GETTEXT_BINARY_DIR ${GETTEXT_MSGFMT_EXECUTABLE} PATH)
    get_filename_component(GETTEXT_DIR ${GETTEXT_BINARY_DIR} PATH)
  endif()
  set(GETTEXT_INCLUDE_DIR ${GETTEXT_DIR}/include)
  set(GETTEXT_LIBRARY_DIR ${GETTEXT_DIR}/lib)
  include_directories(${GETTEXT_INCLUDE_DIR})
  link_directories(${GETTEXT_LIBRARY_DIR})
  if(WIN32)
    set(GETTEXT_LIBRARIES intl)
  elseif(APPLE)
    set(GETTEXT_LIBRARIES intl)
    #set(GETTEXT_STATIC_LIBRARIES
    #  ${GETTEXT_LIBRARY_DIR}/libintl.a 
    #  ${GETTEXT_LIBRARY_DIR}/libiconv.a
    #  System.B 
    #  /System/Library/Frameworks/CoreFoundation.framework)
  else()
    set(GETTEXT_LIBRARIES "")
  endif()
  if(MSVC)
    #install_external_libraries(${GETTEXT_BINARY_DIR} ${GETTEXT_LIBRARY_DIR} ${GETTEXT_LIBRARIES})
    if(CMAKE_CL_64)
      install(FILES thirdparty/windows64/bin/libintl-8.dll DESTINATION bin)
    else()
      install(FILES thirdparty/windows/bin/intl.dll DESTINATION bin)
    endif()
    if(INSTALL_SDK)
      if(CMAKE_CL_64)
        install(FILES thirdparty/windows64/lib/intl.lib DESTINATION lib)
      else()
        install(FILES thirdparty/windows/lib/intl.lib DESTINATION lib)
      endif()
      install(FILES "${GETTEXT_INCLUDE_DIR}/libintl.h" DESTINATION ${CNOID_HEADER_SUBDIR})
    endif()
  endif()
else()
  set(GETTEXT_LIBRARIES "")
endif()

# Python
if(WIN32)
  option(ENABLE_PYTHON "Enable Python functions" OFF)
else()
  option(ENABLE_PYTHON "Enable Python functions" ON)
endif()

if(ENABLE_PYTHON)
  find_package(PythonLibs 2.7 REQUIRED)
  include_directories(${PYTHON_INCLUDE_PATH})
  set(CNOID_PYTHON_SUBDIR ${CNOID_PLUGIN_SUBDIR}/python)
  set(init_py "${PROJECT_BINARY_DIR}/${CNOID_PYTHON_SUBDIR}/cnoid/__init__.py")
  file(WRITE ${init_py} "")
  install(FILES ${init_py} DESTINATION ${CNOID_PYTHON_SUBDIR}/cnoid
    CONFIGURATIONS Release Debug RelWithDebInfo MinSizeRel)
endif()

# boost

# set(Boost_NO_SYSTEM_PATHS true)

set(Boost_USE_STATIC_LIBS OFF)
set(Boost_ADDITIONAL_VERSIONS "1.42" "1.42.0" "1.43" "1.43.0" "1.44" "1.44.0" "1.45" "1.45.0" "1.46" "1.46.0" "1.46.1" "1.47" "1.47.0" "1.48" "1.48.0" "1.49.0" "1.50.0")


if(MSVC)
  find_package(Boost 1.36.0 QUIET OPTIONAL_COMPONENTS  bzip2 zlib)
endif()

set(boost_packages system filesystem program_options regex thread iostreams date_time)

if(ENABLE_PYTHON)
  set(boost_packages ${boost_packages} python)
endif()

find_package(Boost 1.36.0 REQUIRED COMPONENTS ${boost_packages})

if(NOT Boost_FOUND)
  set(BOOST_ROOT ${BOOST_ROOT} CACHE PATH "set the directory of the boost root")
  set(BOOST_LIBRARYDIR ${BOOST_LIBRARYDIR} CACHE PATH "set the directory of the boost library")
  message(FATAL_ERROR "Boost cannot be found. Please specify the boost top directory to BOOST_ROOT.")
endif()

if(Boost_VERSION GREATER "104699")
  find_package(Boost 1.47.0 REQUIRED COMPONENTS chrono)
endif()

include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_RELEASE BOOST_DISABLE_ASSERTS)

install_external_libraries(${Boost_LIBRARY_DIRS} ${Boost_LIBRARY_DIRS}
  ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY} ${Boost_THREAD_LIBRARY} 
  ${Boost_DATE_TIME_LIBRARY} ${Boost_REGEX_LIBRARY} ${Boost_CHRONO_LIBRARY} ${Boost_PYTHON_LIBRARY} 
  ${Boost_IOSTREAMS_LIBRARY} ${Boost_ZLIB_LIBRARY})


if(INSTALL_SDK_WITH_EXTLIBS)
  foreach(dir ${Boost_INCLUDE_DIRS})
    if(EXISTS ${dir}/boost)
      install(DIRECTORY ${dir}/boost DESTINATION ${CNOID_HEADER_SUBDIR})
    endif()
  endforeach()
endif()

if(MSVC)
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS BOOST_ALL_DYN_LINK ${BOOST_LIB_DIAGNOSTIC})

  #MSVC 2010 problem
  if(MSVC_VERSION EQUAL 1600)
    # for VC++2010 Express Edition
    IF(NOT DEFINED CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS)
      SET(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
    ENDIF()
  endif()
endif()

# eigen
if(NOT EIGEN_DIR)
  if(UNIX)
    pkg_check_modules(EIGEN eigen3)
    if(EIGEN_FOUND)
      set(EIGEN_DIR ${EIGEN_INCLUDE_DIRS})
    endif()
  endif()
else()
  set(EIGEN_INCLUDE_DIRS ${EIGEN_DIR})
endif()

set(EIGEN_DIR ${EIGEN_DIR} CACHE PATH "The directory of the Eigen library")

if(NOT EIGEN_INCLUDE_DIRS)
  message(FATAL_ERROR "Please specify the Eigen directory to EIGEN_DIR.")
else()
  include_directories(${EIGEN_INCLUDE_DIRS})
endif()

=== misc/pkgconfig/CMakeLists.txt ===

foreach(file choreonoid.pc choreonoid-body-plugin.pc)
  configure_file(${file}.in ${PROJECT_BINARY_DIR}/lib/pkgconfig/${file} @ONLY)
  if(INSTALL_SDK)
    install(FILES ${PROJECT_BINARY_DIR}/lib/pkgconfig/${file} DESTINATION lib/pkgconfig)
  endif()
endforeach()

=== sample/CameraImageOverlay/CMakeLists.txt ===

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_CAMERA_IMAGE_OVERLAY_SAMPLE "Building a sample of overlaying a camea image" OFF)

if(BUILD_CAMERA_IMAGE_OVERLAY_SAMPLE)
  pkg_check_modules(OPENCV opencv)
  if(OPENCV_FOUND)
    include_directories(${OPENCV_INCLUDE_DIRS})
    set(target CnoidCameraImageOverlayPlugin)
    add_cnoid_plugin(${target} SHARED CameraImageOverlayPlugin.cpp)
    target_link_libraries(${target} CnoidBase ${OPENCV_LIBRARIES})
    apply_common_setting_for_plugin(${target})
  endif()
endif()

=== sample/HelloWorldPlugin/CMakeLists.txt ===

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_HELLO_WORLD_SAMPLE "Building a Hello World sample plugin" OFF)

if(BUILD_HELLO_WORLD_SAMPLE)
  set(target CnoidHelloWorldPlugin)
  add_cnoid_plugin(${target} SHARED HelloWorldPlugin.cpp)
  target_link_libraries(${target} CnoidBase)
  apply_common_setting_for_plugin(${target})

  if(QT5)
    qt5_use_modules(${target} Widgets)
  endif()
endif()

install_sample_source(HelloWorldPlugin.cpp)

=== sample/Roki/CMakeLists.txt ===
if(NOT ENABLE_GUI)
  return()
endif()

if(NOT BUILD_ROKI_PLUGIN)
  return()
endif()

add_cnoid_simple_controller(Arm2dofController Arm2dofController.cpp)
configure_file(RokiArm2Dof.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(arm_2dof.yaml ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(arm_2dof.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(arm_2dof.body ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(RokiFallingBoxes.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(RokiBreakWall.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(breakWall.yaml ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(breakWall.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(breakWall.body ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)

=== sample/SpringModel/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka
if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_SPRING_MODEL_SAMPLE "Building a spring model sample" OFF)

if(BUILD_SPRING_MODEL_SAMPLE)
  
  configure_file(SpringModel.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
  configure_file(CustomizedSpringModel.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)

  if(NOT BUILD_SIMPLE_CONTROLLER_PLUGIN)
    message(WARNING "The spring model sample controller needs SimpleControllerPlugin.")
  else()
    add_cnoid_simple_controller(SpringModelController SpringModelController.cpp)
    configure_file(ControlledSpringModel.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)

    add_cnoid_body_customizer(SpringModelCustomizer SpringModelCustomizer.cpp)
    configure_file(CustomizedSpringModel.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
  endif()

endif()

=== sample/Submersible/CMakeLists.txt ===

#set(CMAKE_BUILD_TYPE Debug)

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_SUBMERSIBLE_SAMPLE "Building a sabumersible sample" OFF)
if(NOT BUILD_SUBMERSIBLE_SAMPLE)
  return()
endif()

set(sources
  SubmersibleSamplePlugin.cpp
  SubmersibleSimulatorItem.cpp
)

set(target CnoidSubmersibleSamplePlugin)
add_cnoid_plugin(${target} SHARED ${sources})
target_link_libraries(${target} CnoidBodyPlugin)
apply_common_setting_for_plugin(${target})

configure_file(submersible.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(submersible.body ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(FogUnderWater.wrl ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(SubmersibleSample.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)

=== src/BulletPlugin/CMakeLists.txt ===

option(BUILD_BULLET_PLUGIN "Building BulletPlugin" OFF)

if(NOT BUILD_BULLET_PLUGIN)
  return()
endif()

#set(CMAKE_BUILD_TYPE Debug)

set(BULLET_DIR ${BULLET_DIR} CACHE PATH "set the top directory of the Bullet Physics library")
if(UNIX)
  if(NOT BULLET_DIR)
    PKG_CHECK_MODULES(bullet REQUIRED bullet)
    # HACD is not included in bullet.pc, we thus have to add it ourselves.
    LIST(APPEND ${bullet_LIBRARIES} HACD)
  else()
    set(bullet_INCLUDE_DIRS ${BULLET_DIR}/include/bullet)
    set(bullet_LIBRARY_DIRS ${BULLET_DIR}/lib/)
    set(bullet_LIBRARIES BulletDynamics BulletCollision LinearMath HACD)
  endif()

elseif(MSVC)
  if(NOT BULLET_DIR)
    message(FATAL_ERROR "Please specify the directory of the Bullet Physics library to BULLET_DIR.")
  endif()
  if(BULLET_DIR)
    set(bullet_LIBRARIES optimized BulletCollision optimized BulletDynamics optimized LinearMath optimized HACD
                         debug BulletCollision_Debug debug BulletDynamics_Debug debug LinearMath_Debug debug HACD_Debug)
    set(bullet_INCLUDE_DIRS ${BULLET_DIR}/include/bullet ${BULLET_DIR}/src ${BULLET_DIR}/Extras)
    set(bullet_LIBRARY_DIRS ${BULLET_DIR}/lib/)
    add_definitions(-DBT_VER_GT_281 -DBT_USE_DOUBLE_PRECISION)
  endif()
endif()

add_definitions(${bullet_CFLAGS})

if(UNIX)
  if(${bullet_VERSION} VERSION_GREATER 2.81)
    add_definitions(-DBT_VER_GT_281)
  endif()
endif()

include_directories(${bullet_INCLUDE_DIRS})
link_directories(${bullet_LIBRARY_DIRS})

set(target CnoidBulletPlugin)

if(MSVC)
  link_directories(${bullet_LIBRARY_DIRS}/Release)
endif()

set(sources
  BulletPlugin.cpp
  BulletSimulatorItem.cpp
  BulletCollisionDetector.cpp
  )

set(headers
  )

make_gettext_mofiles(${target} mofiles)
add_cnoid_plugin(${target} SHARED ${sources} ${headers} ${mofiles})
target_link_libraries(${target} CnoidBodyPlugin ${bullet_LIBRARIES})
apply_common_setting_for_plugin(${target} "${headers}")
install_external_libraries(${BULLET_DIR}/bin ${BULLET_DIR}/lib ${bullet_LIBRARIES})

if(ENABLE_PYTHON)
  add_subdirectory(python)
endif()

=== src/Choreonoid/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

set(target choreonoid)

set(sources main.cpp)

if(NOT QT5)
  QT4_ADD_RESOURCES(RC_SRCS choreonoid.qrc)
else()
  QT5_ADD_RESOURCES(RC_SRCS choreonoid.qrc)
endif()


if(WIN32)
  set(sources ${sources} choreonoid.rc)
endif()

add_cnoid_executable(${target} ${sources} ${RC_SRCS})
target_link_libraries(${target} CnoidUtil CnoidBase)
set_target_properties(${target} PROPERTIES PROJECT_LABEL Application)

if(QT5)
  qt5_use_modules(${target} Gui Widgets)
endif()

if(MSVC)
  option(USE_SUBSYSTEM_CONSOLE "Attaching a console of Windows for debugging" OFF)
  if(NOT USE_SUBSYSTEM_CONSOLE)
    set_target_properties(${target} PROPERTIES WIN32_EXECUTABLE true)
  else()
    set_target_properties(${target} PROPERTIES LINK_FLAGS "/SUBSYSTEM:CONSOLE")
  endif()
endif()

#apply_common_setting_for_target(${target})

if(MSVC)
  set_target_properties(${target} PROPERTIES DEBUG_POSTFIX -debug)
endif()

configure_file(icon/choreonoid.svg ${CNOID_SOURCE_SHARE_DIR}/icon/choreonoid.svg COPYONLY)
install(FILES icon/choreonoid.svg DESTINATION ${CNOID_SHARE_SUBDIR}/icon)

#install(TARGETS ${target} RUNTIME DESTINATION bin CONFIGURATIONS Release Debug)

=== src/Corba/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

#set(CMAKE_BUILD_TYPE Debug)

if(NOT ENABLE_CORBA)
  return()
endif()

set(target CnoidCorba)

set(sources
  CorbaUtil.cpp	
  )

set(headers
  CorbaUtil.h
  )

add_cnoid_library(${target} SHARED ${sources} ${headers})
target_link_libraries(${target} ${OMNIORB_LIBRARIES} ${Boost_THREAD_LIBRARY}) # omniDynamic4 
apply_common_setting_for_library(${target} "${headers}")

# name server
set(target cnoid-nameserver)
idl_compile_cpp(idl_cpp_files idl_h_files corba Naming)
add_cnoid_executable(${target} NameServer.cpp CosNaming_impl.cpp ${idl_cpp_files})
target_link_libraries(${target} ${OMNIORB_LIBRARIES} ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})


if(ENABLE_PYTHON)
  add_subdirectory(python)
endif()

=== src/CorbaPlugin/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

#set(CMAKE_BUILD_TYPE Debug)

option(BUILD_CORBA_PLUGIN "Build CORBA Plugin" OFF)

if(NOT BUILD_CORBA_PLUGIN)
  return()
elseif(NOT ENABLE_CORBA)
  message(FATAL_ERROR "CorbaPlugin needs to ENABLE_CORBA")
endif()

idl_compile_cpp(idl_cpp_files idl_h_files corba MessageView)

set(target CnoidCorbaPlugin)

set(sources
  CorbaPlugin.cpp
  NameServerView.cpp
  MessageView_impl.cpp
  )

set(headers
  CorbaPlugin.h
  )

make_gettext_mofiles(${target} mofiles)
add_cnoid_plugin(${target} SHARED ${sources} ${headers} ${mofiles} ${idl_cpp_files})
target_link_libraries(${target} CnoidUtil CnoidCorba CnoidBase)
apply_common_setting_for_plugin(${target} "${headers}")

if(QT5)
  qt5_use_modules(${target} OpenGL Network)
endif()

# test program
# add_cnoid_executable(corba-test test.cpp ${idl_cpp_files})
# target_link_libraries(corba-test CnoidCorba ${OMNIORB_LIBRARIES})

=== src/OpenHRPPlugin/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

option(BUILD_OPENHRP_PLUGIN "Building OpenHRPPlugin" OFF)
option(BUILD_OPENHRP_PLUGIN_FOR_3_0 "Building OpenHRPPlugin for OpenHRP 3.0.x" OFF)

if(NOT BUILD_OPENHRP_PLUGIN)
  return()
elseif(NOT BUILD_OPENRTM_PLUGIN)
  message(FATAL_ERROR "OpenHRP Plugin requires OpenRTMPlugin.")
endif()

# set(CMAKE_BUILD_TYPE Debug)

if(BUILD_OPENHRP_PLUGIN_FOR_3_0)
  set(versions 3.1 3.0)
else()
  set(versions 3.1)
endif()

if(UNIX AND NOT APPLE)
  # Is this necessary to use both plugins for version 3.0 and 3.1 at the same time ?
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
endif()

include_directories(${OPENRTM_INCLUDE_DIRS})
link_directories(${OPENRTM_LIBRARY_DIRS})

foreach(version ${versions})

  #-------------------- Sutbs & Skeletons -------------------------
  set(idls
    OpenHRPCommon
    ModelLoader
    DynamicsSimulator
    CollisionDetector
    ViewSimulator
    Controller
    OnlineViewer)

  if(version EQUAL 3.0)
    set(defver "OPENHRP_3_0")
  else()
    set(defver "OPENHRP_3_1")
    set(idls ${idls}
      World
      InterpreterService)
  endif()

  set(sources
    OpenHRPControllerBase.cpp
    )
  set(headers
    OpenHRPControllerBase.h
    )
  make_headers_public(OpenHRPControllerBase.h)

  set(target CnoidOpenHRP${version})

  set(idl_cpp_files "")
  set(idl_h_files "")
  idl_compile_cpp(idl_cpp_files idl_h_files corba/OpenHRP/${version} ${idls})

  add_cnoid_library(${target} STATIC ${sources} ${idl_cpp_files} ${idl_h_files})
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS ${defver})
  target_link_libraries(${target} CnoidCorba)
  apply_common_setting_for_library(${target} "${headers}")

  # Plugin
  set(target CnoidOpenHRP${version}Plugin)

  set(sources
    OpenHRPPlugin.cpp
    DynamicsSimulator_impl.cpp
    OpenHRPControllerItem.cpp
    OnlineViewerServer.cpp
    OpenHRPOnlineViewerItem.cpp
    )

  if(version EQUAL 3.1)
    set(sources ${sources}
      OpenHRPInterpreterServiceItem.cpp)
  endif()
  
  set(headers
    exportdecl.h
    )
  
  if(MSVC)
    add_definitions(-D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4 -D_CRT_SECURE_NO_DEPRECATE -D_WIN32_WINNT=0x0500 -DRTC_CORBA_CXXMAPPING11)
  endif()

  make_gettext_mofiles(${target} mofiles)
  add_cnoid_plugin(${target} SHARED ${sources} ${headers} ${mofiles})
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS ${defver})

  if(version EQUAL 3.0)
    target_link_libraries(${target} CnoidBodyPlugin CnoidOpenHRP${version})
  else()
    target_link_libraries(${target} CnoidOpenRTMPlugin CnoidBodyPlugin CnoidOpenHRP${version})
  endif()

  apply_common_setting_for_plugin(${target} "${headers}")

endforeach()

if(ENABLE_PYTHON)
  add_subdirectory(python)
endif()

## choreonoid 1.5.0+dfsg

=== ext/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

# if(ENABLE_INSTALL_RPATH)
#   unset(CMAKE_INSTALL_RPATH)
# endif()

file(GLOB subdirs "*")

foreach(subdir ${subdirs})
  if(EXISTS ${subdir}/CMakeLists.txt)
    add_subdirectory(${subdir})
  endif()
endforeach()

=== misc/CMakeLists.txt ===

add_subdirectory(script)
add_subdirectory(pkgconfig)

=== sample/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

function(install_sample_source)
  if(INSTALL_SDK)
    get_filename_component(name ${CMAKE_CURRENT_SOURCE_DIR} NAME)
    foreach(file ${ARGV})
      install(FILES ${file} DESTINATION ${CNOID_SHARE_SUBDIR}/sample/${name}/)
    endforeach()
    install(FILES ManualMakefile DESTINATION ${CNOID_SHARE_SUBDIR}/sample/${name} RENAME Makefile)
  endif()
endfunction()

file(GLOB subdirs "*")

foreach(subdir ${subdirs})
  if(EXISTS ${subdir}/CMakeLists.txt)
    add_subdirectory(${subdir})
  endif()
endforeach()

=== src/CMakeLists.txt ===

add_subdirectory(Util)
add_subdirectory(Python)
add_subdirectory(AISTCollisionDetector)
add_subdirectory(Body)
add_subdirectory(Corba)

if(ENABLE_GUI)
  add_subdirectory(Base)
  add_subdirectory(PythonPlugin)
  add_subdirectory(BodyPlugin)
  add_subdirectory(PoseSeqPlugin)
  add_subdirectory(BalancerPlugin)
  add_subdirectory(SimpleControllerPlugin)
  add_subdirectory(ODEPlugin)
  add_subdirectory(BulletPlugin)
  add_subdirectory(PhysXPlugin)
  add_subdirectory(RokiPlugin)
  add_subdirectory(AgXPlugin)
  add_subdirectory(FCLPlugin)
  add_subdirectory(SceneEditPlugin)
  add_subdirectory(PCLPlugin)
  
  add_subdirectory(MediaPlugin)
  add_subdirectory(ScenarioPlugin)
  
  add_subdirectory(CorbaPlugin)
  add_subdirectory(OpenRTMPlugin)
  add_subdirectory(OpenHRPPlugin)
  
  add_subdirectory(RobotAccessPlugin)
  add_subdirectory(Hrpsys31Plugin)
  
  add_subdirectory(GrxUIPlugin)
  add_subdirectory(PythonSimScriptPlugin)

  add_subdirectory(Choreonoid)
endif()

=== misc/script/CMakeLists.txt ===

configure_file(make_header_public.rb.in make_header_public.rb @ONLY)
configure_file(make_binary_package.sh.template ${CMAKE_CURRENT_SOURCE_DIR}/make_binary_package.sh @ONLY)
configure_file(make_src_archive.sh.in ${CMAKE_CURRENT_SOURCE_DIR}/make_src_archive.sh @ONLY)

if(WIN32)
  configure_file(install_win32_deps.rb.template ${CMAKE_CURRENT_SOURCE_DIR}/install_win32_deps.rb)
endif()

=== sample/AgX/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_AGX_SAMPLES "Building samples of the AgX dynamics" OFF)

if(NOT BUILD_AGX_SAMPLES)
  return()
endif()
if(NOT BUILD_AGX_PLUGIN)
  message(FATAL_ERROR "AgX samples need to build AgXPlugin.")
endif()

# set(CMAKE_BUILD_TYPE Debug)

add_cnoid_simple_controller(AgXTrackedVehicleController AgXTrackedVehicleController.cpp)
configure_file(AgXTrackedVehicle.body ${CNOID_SOURCE_SHARE_DIR}/model/misc COPYONLY)
configure_file(AgXTrackedVehicle.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)

=== sample/CollisionHandler/CMakeLists.txt ===

#set(CMAKE_BUILD_TYPE Debug)

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_COLLISION_HANDLER_SAMPLE "Building a collision handler sample" OFF)
if(NOT BUILD_COLLISION_HANDLER_SAMPLE)
  return()
endif()

set(sources
  SpringDamperContactPlugin.cpp
)

set(target CnoidSpringDamperContactPlugin)
add_cnoid_plugin(${target} SHARED ${sources})
target_link_libraries(${target} CnoidBodyPlugin)
apply_common_setting_for_plugin(${target})

configure_file(SR1Liftup-SpringDamperContact.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(SetupSR1SpringDamperContact.py ${CNOID_SOURCE_SHARE_DIR}/script COPYONLY)

=== sample/ContactForceExtraction/CMakeLists.txt ===

#set(CMAKE_BUILD_TYPE Debug)

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_CONTACT_FORCE_EXTRACTION_SAMPLE "Building a sample for extracting contact forces" OFF)
if(NOT BUILD_CONTACT_FORCE_EXTRACTION_SAMPLE)
  return()
endif()

set(sources
  ContactForceExtractionSamplePlugin.cpp
)

set(target CnoidContactForceExtractionSamplePlugin)
add_cnoid_plugin(${target} SHARED ${sources})
target_link_libraries(${target} CnoidBodyPlugin)
apply_common_setting_for_plugin(${target})

configure_file(SR1Liftup-ContactForceExtraction.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)

=== sample/GLGears/CMakeLists.txt ===

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_GL_GEARS_SAMPLE "Building a GL Gears sample plugin" OFF)
set(sources GLGearsPlugin.cpp GLGearsView.cpp GLGearsView.h)

if(BUILD_GL_GEARS_SAMPLE)
  set(target CnoidGLGearsPlugin)
  add_cnoid_plugin(${target} SHARED ${sources})
  target_link_libraries(${target} CnoidBase)
  apply_common_setting_for_plugin(${target})
endif()

install_sample_source(${sources})

=== sample/GRobotPlugin/CMakeLists.txt ===
# @author Shin'ichiro Nakaoka

if(NOT ENABLE_GUI OR APPLE)
  return()
endif()

option(BUILD_GROBOT_PLUGIN "Building GRobotPlugin" OFF)

if(NOT BUILD_GROBOT_PLUGIN)
  return()
endif()
if(APPLE)
  message(FATAL_ERROR "Currently MacOS X does not support GRobotPlugin. Please disable BUILD_GROBOT_PLUGIN.")
endif()

# set(CMAKE_BUILD_TYPE Debug)

set(target CnoidGRobotPlugin)

make_gettext_mofiles(${target} mofiles)

if(NOT QT5)
  QT4_ADD_RESOURCES(RC_SRCS GRobotPlugin.qrc)
else()
  QT5_ADD_RESOURCES(RC_SRCS GRobotPlugin.qrc)
endif()

add_cnoid_plugin(${target} SHARED
  GRobotPlugin.cpp
  GRobotBar.cpp
  GRobotControllerItem.cpp
  GRobotController.cpp
  ${mofiles}
  ${RC_SRCS}
  )

if(UNIX)
  target_link_libraries(${target} CnoidBodyPlugin ${Boost_THREAD_LIBRARY} pthread rt)
elseif(MSVC)
  target_link_libraries(${target} CnoidBodyPlugin ${Boost_THREAD_LIBRARY} ${Boost_DATE_TIME_LIBRARY})
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS "BOOST_ASIO_DISABLE_STD_ARRAY")
endif()

apply_common_setting_for_plugin(${target})

install_external_libraries(${Boost_LIBRARY_DIRS} ${Boost_LIBRARY_DIRS} ${Boost_THREAD_LIBRARY} ${Boost_DATE_TIME_LIBRARY})

add_cnoid_body_customizer(GRobotCustomizer GRobotCustomizer.cpp ${mofile})
target_link_libraries(GRobotCustomizer CnoidUtil)

=== sample/JoystickTest/CMakeLists.txt ===

if(NOT ENABLE_GUI OR WIN32 OR APPLE)
  return()
endif()

option(BUILD_JOYSTICK_TEST_PLUGIN "Building a joystick test plugin" OFF)

if(BUILD_JOYSTICK_TEST_PLUGIN)
  set(target CnoidJoystickTestPlugin)
  add_cnoid_plugin(${target} SHARED JoystickTestPlugin.cpp)
  target_link_libraries(${target} CnoidBase)
  apply_common_setting_for_plugin(${target})
endif()

=== sample/OpenHRP/CMakeLists.txt ===

# @author Shin'ichiro Nakaoka

if(NOT ENABLE_GUI)
  return()
endif()

option(BUILD_OPENHRP_SAMPLES "Building OpenHRP samples" OFF)

if(NOT BUILD_OPENHRP_SAMPLES)
  return()
elseif(NOT BUILD_OPENHRP_PLUGIN OR NOT BUILD_SIMPLE_CONTROLLER_PLUGIN)
  message(FATAL_ERROR "OpenHRP samples need to enable BUILD_OPENHRP_PLUGIN and BUILD_SIMPLE_CONTROLLER_PLUGIN.")
endif()

if(BUILD_OPENHRP_PLUGIN_FOR_3_0)
  set(versions 3.1 3.0)
else()
  set(versions 3.1)
endif()

foreach(version ${versions})

  if(version EQUAL 3.0)
    set(defver "OPENHRP_3_0")
  else()
    set(defver "OPENHRP_3_1")
  endif()

  # SR1 walk
  set(target openhrp${version}-sr1-walk-controller)
  add_cnoid_executable(${target} SimpleControllerWrapper.cpp ../SimpleController/SR1WalkPatternController.cpp)
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS "${defver};MODELFILE=\"SR1/SR1.wrl\"")
  target_link_libraries(${target} CnoidOpenHRP${version} CnoidSimpleController)
  
  # SR1 lifting up
  set(target openhrp${version}-sr1-liftup-controller)
  add_cnoid_executable(${target} SimpleControllerWrapper.cpp ../SimpleController/SR1LiftupController.cpp)
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS "${defver};MODELFILE=\"SR1/SR1.wrl\"")
  target_link_libraries(${target} CnoidOpenHRP${version} CnoidSimpleController)
  
  # PA10 Pickup
  set(target openhrp${version}-pa10-pickup-controller)
  add_cnoid_executable(${target} SimpleControllerWrapper.cpp ../SimpleController/PA10PickupController.cpp)
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS "${defver};MODELFILE=\"PA10/PA10.wrl\"")
  target_link_libraries(${target} CnoidOpenHRP${version} CnoidSimpleController)
  
  # test program
  set(target openhrp${version}-online-viewer-test)
  add_cnoid_executable(${target} olv-test.cpp)
  set_target_properties(${target} PROPERTIES COMPILE_DEFINITIONS ${defver})
  target_link_libraries(${target} CnoidOpenHRP${version} CnoidSimpleController ${OMNIORB_LIBRARIES})
  
endforeach()

configure_file(OpenHRP-SR1Walk.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(OpenHRP-SR1Liftup.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(OpenHRP-PA10Pickup.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)
configure_file(OnlineViewer.cnoid ${CNOID_SOURCE_SHARE_DIR}/project COPYONLY)

=== debian/changelog ===
choreonoid (1.5.0+dfsg-0.1build3) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 16:40:33 +0000

choreonoid (1.5.0+dfsg-0.1build2) zesty; urgency=medium

  * No-change rebuild against latest glew

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 06 Nov 2016 21:23:06 -0500

choreonoid (1.5.0+dfsg-0.1build1) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:04:45 +0000

choreonoid (1.5.0+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release Closes: #811639
  * Drop README.source, add all thirdparty (but irrxml) to Files-Excluded
    in debian/copyright.
  * Add repackage suffix option to debian/uscan
  * Refresh patches, drop FTBFS fixes, keep cmake/multiarch patches, keep
    x86_64 -> 64bit fix.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 Aug 2016 10:46:40 +0100

=== debian/control ===
Source: choreonoid
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Moulard <thomas.moulard@gmail.com>
Build-Depends: debhelper (>= 9), cmake,
	       doxygen, doxygen-latex, graphviz,
	       pkg-kde-tools (>= 0.6),
	       libboost-all-dev,
	       libeigen3-dev,
	       libz-dev,
	       libjpeg-dev,
	       libpng-dev,
	       libopenscenegraph-dev,
	       libsimage-dev,
	       libyaml-dev,
	       libqt4-opengl-dev,
	       qt4-dev-tools,
	       qt4-qtconfig,
	       libglew-dev,
	       gettext
Standards-Version: 3.9.4
Section: science
Homepage: http://choreonoid.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/choreonoid.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/choreonoid.git
XS-Testsuite: autopkgtest

Package: choreonoid-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Integrated robotics GUI environment - shared data
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package contains architecture independent files for the
 choreonoid packages.

Package: choreonoid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	 libcnoid1 (= ${binary:Version}),
	 choreonoid-data (= ${source:Version})
Suggests: choreonoid-doc
Multi-Arch: foreign
Description: Integrated robotics GUI environment
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.

Package: libcnoid1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Integrated robotics GUI environment - shared library
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers choreonoid shared libraries.

Package: libcnoid-dev
Architecture: any
Section: libdevel
Depends: libcnoid1 (= ${binary:Version}), ${misc:Depends},
	 libboost-all-dev,
	 libeigen3-dev,
	 libz-dev,
	 libjpeg-dev,
	 libpng-dev,
	 libopenscenegraph-dev,
	 libsimage-dev,
	 libyaml-dev,
	 libqt4-opengl-dev,
	 pkg-config
Multi-Arch: same
Description: Integrated robotics GUI environment - development files
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers development files required to compile Choreonoid
 plug-ins.

Package: choreonoid-dbg
Architecture: any
Section: debug
Depends: choreonoid (= ${binary:Version}), ${misc:Depends}
Multi-Arch: foreign
Description: Choreonoid debugging symbols
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package contains the debugging symbols.

Package: choreonoid-plugins-base
Architecture: any
Depends: ${shlibs:Depends},
	 ${misc:Depends},
	 libcnoid1 (= ${binary:Version})
Enhances: choreonoid
Multi-Arch: foreign
Description: Integrated robotics GUI environment - core plug-ins
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers choreonoid core plug-ins.

Package: choreonoid-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Integrated robotics GUI environment - documentation
 Choreonoid is an integrated robotics GUI environment, which allows
 users to add their own functions on the basis of various basic
 robotics functions.
 .
 This package gathers choreonoid documentation.

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//, repacksuffix=+dfsg" \
http://choreonoid.org/en/download.html .*/_downloads/choreonoid-(.*).zip
